;;; cmucl ffi bindings for librrd
;;; Miles Egan <miles@caddr.com>
;;; $Id: test.lisp,v 1.3 2002/06/04 15:09:52 miles Exp $

(eval-when (:compile-toplevel :load-toplevel :execute)
  (load-foreign "/usr/lib/librrd.so.0"))

(asdf:operate 'asdf:load-op 'com-caddr-rrd)

(defconstant jan-1-1970 (encode-universal-time 0 0 0 1 1 1970 0))
(defun universal-time-to-unix-time (universal-time)
  (- universal-time jan-1-1970))

(profile:profile-all :package 'rrd)

(let* ((rrdname "test.rrd")
      (start (universal-time-to-unix-time (get-universal-time)))
      (step 300)
      (end (+ start (* step 300))))
  
  ;; create the rrd
  (rrd:create
   rrdname
   "--step" (format nil "~S" step)
   (format nil "DS:a:GAUGE:~S:U:U" (* 2 step))
   (format nil "DS:b:GAUGE:~S:U:U" (* 2 step))
   (format nil "RRA:AVERAGE:0.5:1:~S" step))
  
  ;; add data
  (do* ((time start (+ time 300)))
      ((= time end) nil)
    (let ((str (format nil "~S:~S:~S"
		       time
		       (random 100)
		       (+ (* (sin (/ time 800)) 50) 50))))
      (rrd:update rrdname str)))

  ;; graph it
  (rrd:graph
   "test.png"
   "--title" "CMUCL RRD Demo"
   "--start" (format nil "~S" start)
   "--end" (format nil "~S" end)
   "--interlace"
   "--imgformat" "PNG"
   "--width" "800"
   "--height" "400"
   (format nil "DEF:a=~A:a:AVERAGE" rrdname)
   (format nil "DEF:b=~A:b:AVERAGE" rrdname)
   "CDEF:line=TIME,2400,%,300,LT,a,UNKN,IF"
   "AREA:b#00b6e4:beta"
   "AREA:line#0022e9:alpha"
   "LINE3:line#ff0000")

  (profile:report-time))

(quit)
